## libcontra 0.2.2

=== CMakeLists.txt ===
#
#  libcontra - LIBrary for CONnection TRAcking
#
#  Copyright 2018 Thorsten Alteholz <libcontra@alteholz.eu>
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 3 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program (see the file COPYING included with this
#  distribution); if not, write to the Free Software Foundation, Inc.,
#  59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
if ( ${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR} )
    message( FATAL_ERROR "In-source builds not allowed. Please make a new directory (called a build directory) and run CMake from there. You may need to remove CMakeCache.txt." )
endif()

CMAKE_MINIMUM_REQUIRED (VERSION 3.7)
PROJECT(libcontra)

SET(LATEX_OUTPUT_PATH build)
INCLUDE(docu/UseLATEX.cmake)

file(GLOB_RECURSE contents_files RELATIVE ${CMAKE_SOURCE_DIR} docu/*.tex)

ADD_LATEX_DOCUMENT(
    docu/handbook.tex
    INPUTS ${contents_files}
    IMAGE_DIRS docu/images
#    BIBFILES bibliography.bib
#    USE_INDEX
#    USE_GLOSSARY
#    FILTER_OUTPUT
    )

SET(libcontra_VERSION_MAJOR 0)
SET(libcontra_VERSION_MINOR 1)

ADD_SUBDIRECTORY(libcontra) 

include(CTest)
enable_testing()
add_subdirectory(testlib)

=== libcontra/CMakeLists.txt ===
#
#  libcontra - LIBrary for CONnection TRAcking
#
#  Copyright 2018 Thorsten Alteholz <libcontra@alteholz.eu>
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; version 2 of the License
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program (see the file COPYING included with this
#  distribution); if not, write to the Free Software Foundation, Inc.,
#  59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
cmake_minimum_required(VERSION 3.18)
project(ConTra)

ADD_SUBDIRECTORY(src) 
FIND_PACKAGE(Doxygen)

### IF (DOXYGEN_FOUND)

SET(DOXYGEN_INPUT ${CMAKE_SOURCE_DIR}/libcontra/Doxyfile.libcontra)
SET(DOXYGEN_OUTPUT ${CMAKE_SOURCE_DIR}/doxygen-doc)

ADD_CUSTOM_COMMAND(
  OUTPUT ${DOXYGEN_OUTPUT}
  COMMAND ${CMAKE_COMMAND} -E echo_append "Building API Documentation n ..."
  COMMAND pwd
  COMMAND rm -rf ${CMAKE_SOURCE_DIR}/doxygen-doc
  COMMAND mkdir ${CMAKE_SOURCE_DIR}/doxygen-doc
  COMMAND ${DOXYGEN_EXECUTABLE} ${DOXYGEN_INPUT}
  COMMAND ${CMAKE_COMMAND} -E echo "Done n."
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
  DEPENDS ${DOXYGEN_INPUT}
  )

ADD_CUSTOM_TARGET(doc ALL DEPENDS ${DOXYGEN_OUTPUT})

ADD_CUSTOM_TARGET(doc_forced
  COMMAND ${CMAKE_COMMAND} -E echo_append "Building API Documentation f ..."
  COMMAND pwd
  COMMAND rm -rf ${CMAKE_SOURCE_DIR}/doxygen-doc
  COMMAND mkdir ${CMAKE_SOURCE_DIR}/doxygen-doc
  COMMAND ${DOXYGEN_EXECUTABLE} ${DOXYGEN_INPUT}
  COMMAND ${CMAKE_COMMAND} -E echo "Done f."
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

### ENDIF (DOXYGEN_FOUND)

=== testlib/CMakeLists.txt ===
#
#  libcontra - LIBrary for CONnection TRAcking
#
#  Copyright 2018-2023 Thorsten Alteholz <libcontra@alteholz.eu>
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 3 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program (see the file COPYING included with this
#  distribution); if not, write to the Free Software Foundation, Inc.,
#  59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
cmake_minimum_required(VERSION 3.18)
project(ConTra)

add_test(NAME contra_test_start COMMAND echo "start overall tests")
add_test(NAME contra_test_pwd COMMAND ../../testlib/test_pwd_script) # just check whether tests are really running
add_test(NAME contra_test_server COMMAND ./test_server)              # direct call of test_server in order to see whether is was built
add_test(NAME contra_test_00 COMMAND ../../testlib/test_server_00)   # testcase 00
add_test(NAME contra_test_01 COMMAND ../../testlib/test_server_01)   # testcase 01, socket()
add_test(NAME contra_test_02 COMMAND ../../testlib/test_server_02)   # testcase 02, bind()
add_test(NAME contra_test_03 COMMAND ../../testlib/test_server_03)   # testcase 03, listen()
add_test(NAME contra_test_04 COMMAND ../../testlib/test_server_04)   # testcase 04, accept() + connect()
add_test(NAME contra_test_05 COMMAND ../../testlib/test_server_05)   # testcase 05, recv() + send()
add_test(NAME contra_test_06 COMMAND ../../testlib/test_server_06)   # testcase 06, setsockopt() + getsockopt
add_test(NAME contra_test_07 COMMAND ../../testlib/test_server_07)   # testcase 07, gethostbyname() + gethostbyaddr()
add_test(NAME contra_test_08 COMMAND ../../testlib/test_server_08)   # testcase 08, freeaddrinfo() + getaddrinfo()
add_test(NAME contra_test_end COMMAND echo "end overall tests")

add_executable(test_server test_server.c ../libcontra/src/libcontra_log.c)
TARGET_INCLUDE_DIRECTORIES(test_server PUBLIC ../libcontra/src)

add_executable(test_client test_client.c ../libcontra/src/libcontra_log.c)
TARGET_INCLUDE_DIRECTORIES(test_client PUBLIC ../libcontra/src)

=== libcontra/src/CMakeLists.txt ===
#
#  libcontra - LIBrary for CONnection TRAcking
#
#  (C) 2017-2023 Thorsten Alteholz <libcontra@alteholz.eu>
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; version 2 of the License
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program (see the file COPYING included with this
#  distribution); if not, write to the Free Software Foundation, Inc.,
#  59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
include(CheckIncludeFile)
include(GNUInstallDirs)

SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIC -Wl,--no-undefined")
ADD_LIBRARY(contra SHARED libcontra.c libcontra_connect.c libcontra_log.c libcontra_socket.c libcontra_close.c libcontra_listen.c libcontra_poll.c libcontra_bind.c libcontra_accept.c libcontra_send.c libcontra_recv.c libcontra_setsockopt.c libcontra_getsockopt.c libcontra_gethostbyname.c libcontra_gethostbyaddr.c libcontra_freeaddrinfo.c libcontra_getaddrinfo.c)
ADD_LIBRARY(contra-only-connect SHARED libcontra-only-connect.c libcontra_connect.c libcontra_log.c)

CHECK_INCLUDE_FILE("sys/types.h" HAVE_SYS_TYPES_H)
CHECK_INCLUDE_FILE("stdbool.h" HAVE_STDBOOL_H) 
CHECK_INCLUDE_FILE("dlfcn.h" HAVE_DLFCN_H)
CHECK_INCLUDE_FILE("arpa/inet.h" HAVE_ARPA_INET_H)
CHECK_INCLUDE_FILE("sys/socket.h" HAVE_SYS_SOCKET_H)
CHECK_INCLUDE_FILE("netdb.h" HAVE_NETDB_H)
CHECK_INCLUDE_FILE("errno.h" HAVE_ERRNO_H)
CHECK_INCLUDE_FILE("stdlib.h" HAVE_STDLIB_H)
CHECK_INCLUDE_FILE("stdio.h" HAVE_STDIO_H)
CHECK_INCLUDE_FILE("string.h" HAVE_STRING_H)
CHECK_INCLUDE_FILE("stdarg.h" HAVE_STDARG_H)
CHECK_INCLUDE_FILE("pthread.h" HAVE_PTHREAD_H)


TARGET_LINK_LIBRARIES(contra -ldl)
TARGET_INCLUDE_DIRECTORIES(contra PUBLIC .)
TARGET_LINK_LIBRARIES(contra-only-connect -ldl)
TARGET_INCLUDE_DIRECTORIES(contra-only-connect PUBLIC .)

# INSTALL(TARGETS contra DESTINATION lib)
# INSTALL(TARGETS contra-only-connect DESTINATION lib)
#INSTALL(TARGETS contra DESTINATION ${CMAKE_INSTALL_LIBDIR})
#INSTALL(TARGETS contra-only-connect DESTINATION ${CMAKE_INSTALL_LIBDIR})

set_target_properties (contra PROPERTIES VERSION 0.2.2 SOVERSION 1)
set_target_properties (contra-only-connect PROPERTIES VERSION 0.2.2 SOVERSION 1)

set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "/usr/lib")
INSTALL(TARGETS contra DESTINATION ${CMAKE_LIBRARY_OUTPUT_DIRECTORY})
INSTALL(TARGETS contra-only-connect DESTINATION ${CMAKE_LIBRARY_OUTPUT_DIRECTORY})

=== debian/changelog ===
libcontra (0.2.2-1) unstable; urgency=medium

  * New upstream release.
  * source upload

 -- Thorsten Alteholz <debian@alteholz.de>  Mon, 04 Dec 2023 19:20:28 +0100

libcontra (0.2.1-1) unstable; urgency=medium

  * initial version

 -- Thorsten Alteholz <debian@alteholz.de>  Tue, 28 Nov 2023 22:20:27 +0100

=== debian/control ===
Source: libcontra
Section: libs
Priority: optional
Maintainer: Thorsten Alteholz <debian@alteholz.de>
Build-Depends: debhelper-compat (= 13)
	, cmake
	, texlive-binaries
	, texlive-latex-base
	, imagemagick
	, doxygen
	, texlive-latex-recommended
Standards-Version: 4.6.2
Homepage: https://git.alteholz.dev/libcontra
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/alteholz/libcontra
Vcs-Git: https://salsa.debian.org/alteholz/libcontra.git

Package: libcontra1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: LIBrary for CONnection TRAcking
 LD_PRELOADing this library enables one to log calls to several
 network functions.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/buildflags.mk

%:
	dh $@ --buildsystem=cmake

override_dh_auto_install:
	dh_auto_install
	-rm ./debian/libcontra1/usr/lib/libcontra-only-connect.so
	-rm ./debian/libcontra1/usr/lib/libcontra.so
	#find


override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_INSTALL_PREFIX=/usr

=== debian/watch ===
version=4
https://git.alteholz.dev/alteholz/libcontra/tags?sort=updated_desc archive/v?\d[\d.]+/libcontra-v?([\d.]+)@ARCHIVE_EXT@ debian uupdate
